Index: file.c
===================================================================
RCS file: /usr/cvsroot/asterisk/file.c,v
retrieving revision 1.58
diff -u -u -r1.58 file.c
--- file.c	22 Mar 2005 20:34:04 -0000	1.58
+++ file.c	30 Mar 2005 14:32:52 -0000
@@ -351,7 +351,7 @@
 	while(f) {
 		if (!fmt || exts_compare(f->exts, fmt)) {
 			char *stringp=NULL;
-			exts = strdup(f->exts);
+			exts = ast_strdupa(f->exts);
 			/* Try each kind of extension */
 			stringp=exts;
 			ext = strsep(&stringp, "|");
@@ -426,7 +426,7 @@
 				}
 				ext = strsep(&stringp, "|");
 			} while(ext);
-			free(exts);
+			
 		}
 		f = f->next;
 	}
@@ -797,7 +797,6 @@
 	struct ast_format *f;
 	struct ast_filestream *fs=NULL;
 	char *fn;
-	char *ext;
 	if (ast_mutex_lock(&formatlock)) {
 		ast_log(LOG_WARNING, "Unable to lock format list\n");
 		return NULL;
@@ -805,12 +804,7 @@
 	f = formats;
 	while(f) {
 		if (exts_compare(f->exts, type)) {
-			char *stringp=NULL;
-			/* XXX Implement check XXX */
-			ext = strdup(f->exts);
-			stringp=ext;
-			ext = strsep(&stringp, "|");
-			fn = build_filename(filename, ext);
+			fn = build_filename(filename, type);
 			fd = open(fn, flags | myflags);
 			if (fd >= 0) {
 				errno = 0;
@@ -829,7 +823,6 @@
 			} else if (errno != EEXIST)
 				ast_log(LOG_WARNING, "Unable to open file %s: %s\n", fn, strerror(errno));
 			free(fn);
-			free(ext);
 			break;
 		}
 		f = f->next;
@@ -846,7 +839,6 @@
 	struct ast_format *f;
 	struct ast_filestream *fs=NULL;
 	char *fn,*orig_fn=NULL;
-	char *ext;
 	char *buf=NULL;
 	size_t size = 0;
 
@@ -867,14 +859,9 @@
 	f = formats;
 	while(f) {
 		if (exts_compare(f->exts, type)) {
-			char *stringp=NULL;
-			/* XXX Implement check XXX */
-			ext = ast_strdupa(f->exts);
-			stringp=ext;
-			ext = strsep(&stringp, "|");
-			fn = build_filename(filename, ext);
+			fn = build_filename(filename, type);
 			fd = open(fn, flags | myflags, mode);
-
+			
 			if (option_cache_record_files && fd >= 0) {
 				close(fd);
 				/*
@@ -903,7 +890,7 @@
 					fs->flags = flags;
 					fs->mode = mode;
 					if (option_cache_record_files) {
-						fs->realfilename = build_filename(filename, ext);
+						fs->realfilename = build_filename(filename, type);
 						fs->filename = strdup(fn);
 					} else {
 						fs->realfilename = NULL;
